## licq 1.5.0

=== CMakeLists.txt ===
project(Licq)
cmake_minimum_required(VERSION 2.6.0)
cmake_policy(VERSION 2.6)

# Internal cmake modules
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)

# Includes
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckFileOffsetBits)

# Options
option(ENABLE_NLS "Enable translation of program messages" ON)
option(USE_FIFO "Use Licq FIFO" ON)
option(USE_HEBREW "Include support for hebrew reverse string" OFF)
option(USE_OPENSSL "Enable secure communication channels" ON)
option(USE_SOCKS5 "Enable socks5 support" OFF)
option(BUILD_PLUGINS "Build all plugins" OFF)
option(BUILD_TESTS "Build all unit tests" OFF)

set(DLOPEN_POLICY RTLD_NOW CACHE STRING "2nd dlopen parameter")
mark_as_advanced(DLOPEN_POLICY)

include(cmake/LicqCommonCompilerFlags.cmake)

# Network libraries (needed on Solaris)
check_library_exists(socket getaddrinfo "" HAVE_LIBSOCKET)
if (HAVE_LIBSOCKET)
  set(SOCKET_LIBRARIES ${SOCKET_LIBRARIES} socket)
endif (HAVE_LIBSOCKET)
check_library_exists(nsl gethostbyname "" HAVE_LIBNSL)
if (HAVE_LIBNSL)
  set(SOCKET_LIBRARIES ${SOCKET_LIBRARIES} nsl)
endif (HAVE_LIBNSL)

# Functions
check_function_exists(readdir_r HAVE_READDIR_R)
check_function_exists(backtrace HAVE_BACKTRACE)

if(CMAKE_SYSTEM MATCHES "SunOS.*")
  # Make readdir_r on Solaris behave normally
  add_definitions(-D_POSIX_PTHREAD_SEMANTICS)
endif(CMAKE_SYSTEM MATCHES "SunOS.*")

# iconv
find_package(Iconv REQUIRED)
if (ICONV_SECOND_ARGUMENT_IS_CONST)
  set(ICONV_CONST "const")
endif (ICONV_SECOND_ARGUMENT_IS_CONST)

# gettext
if (ENABLE_NLS)
  set(GETTEXT_FOUND FALSE)

  find_path(GETTEXT_INCLUDE_DIR libintl.h)
  if (GETTEXT_INCLUDE_DIR)
    set(CMAKE_REQUIRED_LIBRARIES ${ICONV_LIBRARIES})
    check_function_exists(dgettext LIBC_HAS_DGETTEXT)
    if (LIBC_HAS_DGETTEXT)
      set(GETTEXT_FOUND TRUE)
    else (LIBC_HAS_DGETTEXT)
      find_library(LIBINTL_LIBRARY NAMES intl libintl)
      check_library_exists(${LIBINTL_LIBRARY} "dgettext" "" LIBINTL_HAS_DGETTEXT)
      if (LIBINTL_HAS_DGETTEXT)
        set(GETTEXT_LIBRARIES ${LIBINTL_LIBRARY})
        set(GETTEXT_FOUND TRUE)
      endif (LIBINTL_HAS_DGETTEXT)
    endif (LIBC_HAS_DGETTEXT)
    set(CMAKE_REQUIRED_LIBRARIES)
  endif (GETTEXT_INCLUDE_DIR)

  if (NOT GETTEXT_FOUND)
    message(FATAL_ERROR "Gettext NOT found")
  endif (NOT GETTEXT_FOUND)
endif (ENABLE_NLS)

# OpenSSL
if (USE_OPENSSL)
  check_library_exists(crypto DH_free "" have_openssl_crypto)
  if (have_openssl_crypto)
    find_package(OpenSSL)
  endif (have_openssl_crypto)

  if (OPENSSL_FOUND)
    list(APPEND OPENSSL_LIBRARIES crypto)
  else (OPENSSL_FOUND)
    message(STATUS "OpenSSL NOT found; secure communication channels will not be available")
    set(USE_OPENSSL OFF)
  endif (OPENSSL_FOUND)
endif (USE_OPENSSL)

# GPGME
find_package(Gpgme)
if (GPGME_VANILLA_FOUND)
  set(HAVE_LIBGPGME 1)
  check_file_offset_bits()
  if (_FILE_OFFSET_BITS)
      add_definitions(-D_FILE_OFFSET_BITS=${_FILE_OFFSET_BITS})
  endif (_FILE_OFFSET_BITS)
endif (GPGME_VANILLA_FOUND)

# SOCKS5
if (USE_SOCKS5)
  find_path(SOCKS5_INCLUDE_DIR socks.h)
  find_library(SOCKS5_LIBRARY NAMES socks5 socks)
  if (NOT SOCKS5_INCLUDE_DIR OR NOT SOCKS5_LIBRARY)
    message(FATAL_ERROR "SOCKS5 NOT found")
  endif (NOT SOCKS5_INCLUDE_DIR OR NOT SOCKS5_LIBRARY)
  set(SOCKS5_LIBRARIES ${SOCKS5_LIBRARY})
endif (USE_SOCKS5)

# Google Test is needed for unit tests
if (BUILD_TESTS)
  find_package(GTest)
  if (NOT GTEST_FOUND)
    message(FATAL_ERROR
      "Google Test NOT found; disable unit tests by running cmake with -DBUILD_TESTS=OFF")
  endif (NOT GTEST_FOUND)

  enable_testing()
  add_custom_target(tests ALL COMMAND ${CMAKE_CTEST_COMMAND} $(ARGS))

  # Google Mock
  add_subdirectory(3rdparty/gmock)
  set(GMOCK_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/gmock/include")
  set(GMOCK_LIBRARIES gmock gmock_main)
else (BUILD_TESTS)
  message(STATUS "Unit tests disabled")
endif (BUILD_TESTS)

# Set up installation paths
include(cmake/LicqDefaultPaths.cmake)

# Generate config.h
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/include/config.h
)

# Generate licqversion.h
include(cmake/LicqVersion.cmake)

# Doxygen is option
find_package(Doxygen)

if (DOXYGEN_FOUND)
  set(DOXY_CONFIG ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

  message(STATUS "Generating ${DOXY_CONFIG}")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in"
    ${DOXY_CONFIG} @ONLY)

  add_custom_target(docs
    ${DOXYGEN_EXECUTABLE} ${DOXY_CONFIG}
    DEPENDS ${DOXY_CONFIG}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Generating doxygen documentation" VERBATIM)
endif (DOXYGEN_FOUND)

# make uninstall (file added to top binary dir to work with build_all)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake"
  @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake"
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

add_subdirectory(cmake)
add_subdirectory(include)
add_subdirectory(po)
add_subdirectory(share)
add_subdirectory(src)

if (BUILD_PLUGINS)
  add_subdirectory(plugins)
endif (BUILD_PLUGINS)

=== po/CMakeLists.txt ===
set(po_FILES
  be
  de
  es
)

find_package(Gettext REQUIRED)

if (NOT GETTEXT_MSGMERGE_EXECUTABLE AND NOT GETTEXT_MSGFMT_EXECUTABLE)
  message(FATAL_ERROR "Gettext message catalog tools NOT found")
endif (NOT GETTEXT_MSGMERGE_EXECUTABLE AND NOT GETTEXT_MSGFMT_EXECUTABLE)

foreach(lang ${po_FILES})
  set(po  "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po")
  set(gmo "${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo")

  add_custom_command(OUTPUT ${gmo}
    COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE} --quiet --update --backup=none
      --sort-output ${po} ${CMAKE_CURRENT_SOURCE_DIR}/licq.pot
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} -o ${gmo} ${po}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/licq.pot ${po}
  )

  install(FILES ${gmo}
    DESTINATION "${Licq_LOCALE_DIR}/${lang}/LC_MESSAGES"
    RENAME licq.mo
  )

  set(gmoFiles ${gmoFiles} ${gmo})
endforeach(lang)

add_custom_target(translations ALL DEPENDS ${gmoFiles})

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if (GETTEXT_XGETTEXT_EXECUTABLE)
  # Get list of all source files
  file(GLOB_RECURSE po_source
    RELATIVE ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/src/*.c
    ${PROJECT_SOURCE_DIR}/src/*.cpp
  )

  add_custom_command(
    OUTPUT licq.pot
    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE}
      --directory ${PROJECT_SOURCE_DIR}
      --output="${CMAKE_CURRENT_SOURCE_DIR}/licq.pot"
      --default-domain=licq
      --add-comments=TRANSLATORS:
      --keyword=tr
      --keyword=tr_NOOP
      --copyright-holder='Licq Developers'
      --msgid-bugs-address="licq-dev@googlegroups.com"
      --sort-output
      ${po_source}
  )

  add_custom_target(translations_update DEPENDS licq.pot)
endif (GETTEXT_XGETTEXT_EXECUTABLE)

=== src/CMakeLists.txt ===
set(tested_SRCS
  conversation.cpp
  inifile.cpp

  logging/adjustablelogsink.cpp
  logging/log.cpp
  logging/logdistributor.cpp
  logging/logutils.cpp
  logging/pluginlogsink.cpp

  plugins/generalplugin.cpp
  plugins/plugin.cpp
  plugins/pluginthread.cpp
  plugins/protocolplugin.cpp

  thread/condition.cpp
  thread/mutexlocker.cpp
  thread/readwritemutex.cpp

  utils/dynamiclibrary.cpp
  utils/pipe.cpp
)

set(licq_SRCS
  buffer.cpp
  color.cpp
  daemon.cpp
  event.cpp
  fifo.cpp
  gpghelper.cpp
  hebrev.c
  licq.cpp
  main.cpp
  md5.cpp
  oneventmanager.cpp
  packet.cpp
  protocolmanager.cpp
  proxy.cpp
  rtf.cc
  sarmanager.cpp
  sighandler.cpp
  socket.cpp
  socketmanager.cpp
  statistics.cpp
  support.c
  translator.cpp
  userevents.cpp
  utility.cpp

  contactlist/group.cpp
  contactlist/owner.cpp
  contactlist/user.cpp
  contactlist/userhistory.cpp
  contactlist/usermanager.cpp

  icq/chat.cpp
  icq/codes.c
  icq/filetransfer.cpp
  icq/icq-srv.cpp
  icq/icq-tcp.cpp
  icq/icq.cpp
  icq/icqprotocolplugin.cpp
  icq/oscarservice.cpp
  icq/packet.cpp
  icq/threads.cpp

  logging/logservice.cpp
  logging/streamlogsink.cpp
  logging/threadlog.cpp

  plugins/plugineventhandler.cpp
  plugins/pluginmanager.cpp

  ${tested_SRCS}
)

set(test_SRCS
  tests/conversationtest.cpp
  tests/inifiletest.cpp

  logging/tests/adjustablelogsinktest.cpp
  logging/tests/logdistributortest.cpp
  logging/tests/logtest.cpp
  logging/tests/logutilstest.cpp
  logging/tests/pluginlogsinktest.cpp

  plugins/tests/generalplugintest.cpp
  plugins/tests/plugintest.cpp
  plugins/tests/pluginthreadtest.cpp
  plugins/tests/protocolplugintest.cpp

  thread/tests/conditiontest.cpp
  thread/tests/mutextest.cpp
  thread/tests/mutexlockertest.cpp
  thread/tests/readwritemutextest.cpp
  thread/tests/threadspecificdatatest.cpp

  utils/tests/dynamiclibrarytest.cpp
  utils/tests/pipetest.cpp

  # Needed or IniFile won't find gLog
  logging/logservice.cpp
  logging/threadlog.cpp

  # A dummy gDaemon to make tests compile without having to pull in the read daemon.cpp
  tests/daemon_dummy.cpp

  ${tested_SRCS}
)

add_executable(licq ${licq_SRCS})

# Add linker flags for thread support
set_target_properties(licq PROPERTIES LINK_FLAGS "${CMAKE_THREAD_LIBS_INIT}")

# Must export symbols from daemon so that plugins can use them
list(APPEND CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_EXPORTS_CXX_FLAG})

# To find public headers
include_directories(BEFORE ${PROJECT_SOURCE_DIR}/include)

# To find config.h and licqversion.h
include_directories(BEFORE ${PROJECT_BINARY_DIR}/include)

# To find local headers
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

include_directories(${GETTEXT_INCLUDE_DIR})
include_directories(${GPGME_INCLUDES})
include_directories(${ICONV_INCLUDE_DIR})
include_directories(${OPENSSL_INCLUDE_DIR})
include_directories(${SOCKS5_INCLUDE_DIR})

target_link_libraries(licq ${CMAKE_DL_LIBS})
target_link_libraries(licq ${GETTEXT_LIBRARIES})
target_link_libraries(licq ${GPGME_VANILLA_LIBRARIES})
target_link_libraries(licq ${ICONV_LIBRARIES})
target_link_libraries(licq ${OPENSSL_LIBRARIES})
target_link_libraries(licq ${SOCKET_LIBRARIES})
target_link_libraries(licq ${SOCKS5_LIBRARIES})

install(TARGETS licq RUNTIME DESTINATION bin)

if (BUILD_TESTS)
  include_directories(${GTEST_INCLUDE_DIRS})
  include_directories(${GMOCK_INCLUDE_DIRS})

  add_executable(unittests ${test_SRCS})

  target_link_libraries(unittests ${GTEST_LIBRARIES})
  target_link_libraries(unittests ${GMOCK_LIBRARIES})
  target_link_libraries(unittests ${CMAKE_DL_LIBS})
  target_link_libraries(unittests ${SOCKET_LIBRARIES})

  # Add linker flags for thread support
  set_target_properties(unittests PROPERTIES
    LINK_FLAGS "${CMAKE_THREAD_LIBS_INIT}")

  add_test(licq unittests)
  add_dependencies(tests unittests)
endif (BUILD_TESTS)

=== plugins/osd/po/CMakeLists.txt ===
set(po_FILES
  be
  cs
  de
  es
  fr
  pt
  pt_BR
  ro
  ru
  sk
  sv
)

find_package(Gettext REQUIRED)

foreach(lang ${po_FILES})
  set(po  "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po")
  set(gmo "${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo")

  add_custom_command(OUTPUT ${gmo}
    COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE} --quiet --update --backup=none
      --sort-output ${po} ${CMAKE_CURRENT_SOURCE_DIR}/licq_osd_plugin.pot
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} -o ${gmo} ${po}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/licq_osd_plugin.pot ${po}
  )

  install(FILES ${gmo}
    DESTINATION "${Licq_LOCALE_DIR}/${lang}/LC_MESSAGES"
    RENAME licq_osd_plugin.mo
  )

  set(gmoFiles ${gmoFiles} ${gmo})
endforeach(lang)

add_custom_target(${licq_target_prefix}translations ALL DEPENDS ${gmoFiles})

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if (GETTEXT_XGETTEXT_EXECUTABLE)
  # Get list of all source files
  file(GLOB_RECURSE po_source
    RELATIVE ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/src/*.h
    ${PROJECT_SOURCE_DIR}/src/*.cpp
  )

  add_custom_command(
    OUTPUT licq_osd_plugin.pot
    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE}
      --directory ${PROJECT_SOURCE_DIR}
      --output="${CMAKE_CURRENT_SOURCE_DIR}/licq_osd_plugin.pot"
      --default-domain=licq_osd_plugin
      --add-comments=TRANSLATORS:
      --keyword=_
      --keyword=N_
      --copyright-holder='Licq Developers'
      --msgid-bugs-address="licq-dev@googlegroups.com"
      --sort-output
      ${po_source}
  )

  add_custom_target(${licq_target_prefix}translations_update
    DEPENDS licq_osd_plugin.pot)
endif (GETTEXT_XGETTEXT_EXECUTABLE)

=== debian/changelog ===
licq (1.5.0-2) unstable; urgency=low

  * Change vcs url to github
  * Print test output on failure
  * Install icon included in package instead of external (Closes: #628339)
  * Bump standards version to 3.9.2 with no changes
  * Incorporate Ubuntu patches
  * Fix pthread crash on hppa (Closes: #607082)
  * Fix FTBFS with gtest 1.6.0

 -- Erik Johansson <debian@ejohansson.se>  Thu, 16 Jun 2011 21:32:23 +0200

licq (1.5.0-1) unstable; urgency=low

  * New upstream version 1.5.0

 -- Erik Johansson <debian@ejohansson.se>  Sun, 03 Oct 2010 12:23:56 +0200

licq (1.5.0~rc2-2) unstable; urgency=low

  * Minor changes of package descriptions - thanks to Joel R
  * Remove empty /usr/share/licq directory from licq-plugin-qt4 and
    licq-plugin-kde4 - thanks to Joel R

 -- Erik Johansson <debian@ejohansson.se>  Thu, 30 Sep 2010 23:25:22 +0200

licq (1.5.0~rc2-1) unstable; urgency=low

  * New upstream version
    - kde/qt-gui are now fully replaced by kde4/qt4-gui
  * Bumped Standards Version to 3.9.1 with no changes
  * Updated patches for new upstream release
  * Packaged jabber protocol plugin
  * Packaged kde4-gui plugin
  * Moved qt4 data files to a separate package licq-plugin-qt4-common
  * Build system updated for new upstream release
  * licq-plugin-kde/qt are now dummy packages depending on licq-plugin-kde4/qt4

 -- Erik Johansson <debian@ejohansson.se>  Fri, 25 Sep 2010 10:37:34 +0200

=== debian/control ===
Source: licq
Build-Depends: cdbs (>= 0.4.52), cmake (>= 2.6.0), debhelper (>= 6.0.7), imagemagick, kdelibs5-dev, libboost-dev (>= 1.33.1), libcdk5-dev, libgloox-dev (>= 1.0), libgpgme11-dev (>= 0.4.2), libgtest-dev (>= 1.5.0), libhunspell-dev, libncurses5-dev, libqt4-dev (>= 4.3.0), libssl-dev, libxosd-dev (>= 2.1.0), libxss-dev, qt4-dev-tools
Section: net
Priority: optional
Maintainer: Erik Johansson <debian@ejohansson.se>
Standards-Version: 3.9.2
Vcs-Git: git://github.com/licq-im/debian.git
Vcs-Browser: https://github.com/licq-im/debian
Homepage: http://www.licq.org/

Package: licq
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: licq-plugin-qt4 | licq-plugin, sox
Suggests: bind9-host | host, ping, traceroute
Description: multi-protocol instant messaging client (base files)
 Licq is an instant messaging client daemon that supports a number of
 interfaces via plug-ins, primarily KDE or Qt, but also console, and several
 utility plug-ins.  Included in this package is support for AIM and ICQ.
 Support for MSN and Jabber is available as separate plug-ins.
 .
 Implemented features include messaging, chat, file transfer, whitepages,
 history, invisible list, server-side stored contacts, typing
 notification, phone book, user pictures, proxy support, user groups,
 network monitor window, themed docking skin and icon pack support,
 FIFO support for remote control, international support with Unicode and
 translations, per-user customized auto responses, SSL secure client to
 client connections and GPG encrypted messages.
 .
 At least one plug-in is required for Licq to function.  The plug-ins
 are distributed in separate packages named "licq-plugin-*".

Package: licq-dev
Architecture: all
Section: devel
Depends: ${misc:Depends}
Description: Licq development and header files
 This package contains files required to compile Licq plug-ins that are not
 included in the main Licq package.  If you aren't going to compile plug-ins,
 you don't need this package.

Package: licq-plugin-autoreply
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version})
Provides: licq-plugin
Description: autoreply plug-in for Licq
 This is an autoreplier plug-in for the Licq instant messaging client.  Any
 events (messages, URLs, etc.) received while the plug-in is enabled will cause
 the plug-in to reply with the output from any specified program (e.g.,
 fortune).

Package: licq-plugin-console
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version})
Provides: licq-plugin
Description: console user interface plug-in for Licq
 This is a console user interface plug-in for the Licq instant messaging
 client.  It does not have all the features that the Qt GUI supports, but it
 does offer a number of really cool text-mode things such as multiple windows,
 contact list pane and log window.

Package: licq-plugin-forwarder
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version})
Provides: licq-plugin
Description: forwarder plug-in for Licq
 This is a forwarder plug-in for the Licq instant messaging client.  Any events
 (messages, URLs, etc.) received while the plug-in is enabled will be forwarded
 either via SMTP to a given email account or via ICQ to a given UIN.

Package: licq-plugin-jabber
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version})
Provides: licq-plugin
Description: Jabber plug-in for Licq
 This is a plug-in for the Licq instant messaging client that enables
 communication over a Jabber (XMPP) instant messaging network.

Package: licq-plugin-kde
Architecture: all
Depends: licq-plugin-kde4, ${misc:Depends}
Section: oldlibs
Priority: extra
Description: dummy package for transition to licq-plugin-kde4
 This is a transitional dummy package to ease the migration from the deprecated
 licq-plugin-kde to the new licq-plugin-kde4 package.  You can remove it
 safely.

Package: licq-plugin-kde4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version}), licq-plugin-qt4-common
Provides: licq-plugin
Description: graphical user interface plug-in for Licq using KDE4
 This package provides a KDE-based graphical user interface to the Licq instant
 messaging client.  The GUI provides access to all features available in Licq.
 .
 The GUI contains a wide range of configurable options as well as skin support
 allowing behaviour and appearance to be customized in many ways.  Features
 include spell checking, auto-raise and auto-popup incoming messages, tray icon
 and a searchable history.
 .
 KDE4-GUI is based on the old KDE-GUI (licq-plugin-kde) but uses KDE4 and
 includes new features such as spell checking and configurable keyboard
 shortcuts as well as entirely new dialogs for messaging, history and settings.

Package: licq-plugin-msn
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version})
Provides: licq-plugin
Description: MSN plug-in for Licq
 This is a plug-in for the Licq instant messaging client that enables
 communication over the MSN Messenger instant messaging network.

Package: licq-plugin-osd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version})
Provides: licq-plugin
Description: on-screen display plug-in for Licq
 This is a plug-in for the Licq instant messaging client that enables it to
 display new messages as an on-screen display message.  User logged on/off and
 status changed messages are also supported.

Package: licq-plugin-qt
Architecture: all
Depends: licq-plugin-qt4, ${misc:Depends}
Section: oldlibs
Priority: extra
Description: dummy package for transition to licq-plugin-qt4
 This is a transitional dummy package to ease the migration from the deprecated
 licq-plugin-qt to the new licq-plugin-qt4 package.  You can remove it safely.

Package: licq-plugin-qt4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version}), licq-plugin-qt4-common
Provides: licq-plugin
Replaces: licq-plugin-qt (<< 1.3.9-1)
Breaks: licq-plugin-qt (<< 1.3.9-1)
Description: graphical user interface plug-in for Licq using Qt4
 This package provides a Qt-based graphical user interface to the Licq instant
 messaging client.  The GUI provides access to all features available in Licq
 and is the default plug-in for Licq.
 .
 The GUI contains a wide range of configurable options as well as skin support
 allowing behaviour and appearance to be customized in many ways.  Features
 include spell checking, auto-raise and auto-popup incoming messages, tray icon
 and a searchable history.
 .
 By taking advantage of the desktop integration features of Qt4, the GUI can
 adapt to standard desktops with regards to look and feel.  Docking support is
 also available for Window Maker, AfterStep and Enlightment among others.
 .
 Qt4-GUI is based on the old Qt-GUI (licq-plugin-qt) but uses Qt4 and includes
 new features such as spell checking and configurable keyboard shortcuts as
 well as entirely new dialogs for messaging, history and settings.  Note that
 spell checking and tray icon are available even though this version is not
 linked with KDE libraries.

Package: licq-plugin-qt4-common
Architecture: all
Depends: ${misc:Depends}
Replaces: licq-plugin-qt4 (<< 1.5.0~)
Breaks: licq-plugin-qt4 (<< 1.5.0~)
Description: common data files for the Qt4 and KDE4 Licq plugins
 This package contains common skins, icons and similar files that are used by
 the Qt4 and KDE4 plugins for Licq. The package is only of use if at least one
 of licq-plugin-qt4 and licq-plugin-kde4 is installed.

Package: licq-plugin-rms
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, licq (= ${binary:Version})
Provides: licq-plugin
Description: remote management server plug-in for telnet Licq access
 This package provides the means to manage Licq instant messaging sessions
 remotely through a telnet connection.  For obvious reasons, if you don't
 need this plug-in, you probably shouldn't install it.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/langcore.mk

DEB_INSTALL_DOCS_ALL =
DEB_INSTALL_CHANGELOGS_ALL = doc/CHANGELOG
DEB_DH_MAKESHLIBS_ARGS_ALL = -X usr/lib/licq/

# cmake settings
CMAKE = cmake
CMAKE_BUILDDIR = obj-$(DEB_BUILD_GNU_TYPE)
CMAKE_INSTALL_PREFIX = /usr
CMAKE_NORMAL_ARGS  = -DCMAKE_INSTALL_PREFIX="$(CMAKE_INSTALL_PREFIX)"
CMAKE_NORMAL_ARGS += -DCMAKE_C_COMPILER:FILEPATH="$(CC)"
CMAKE_NORMAL_ARGS += -DCMAKE_CXX_COMPILER:FILEPATH="$(CXX)"
CMAKE_NORMAL_ARGS += -DCMAKE_C_FLAGS="$(CFLAGS)"
CMAKE_NORMAL_ARGS += -DCMAKE_CXX_FLAGS="$(CXXFLAGS)"
CMAKE_NORMAL_ARGS += -DCMAKE_SKIP_RPATH=ON
CMAKE_NORMAL_ARGS += -DCMAKE_VERBOSE_MAKEFILE=ON
export CTEST_OUTPUT_ON_FAILURE=1

# plugin packages
PLUGINS := $(patsubst licq-plugin-%,%,$(filter licq-plugin-%,$(shell dh_listpackages)))
PLUGINS := $(filter-out kde qt qt4-common,$(PLUGINS))

# directories of plugin packages in source tree
src/autoreply = auto-reply
src/console   = console
src/forwarder = forwarder
src/jabber    = jabber
src/kde4      = kde4-gui
src/msn       = msn
src/osd       = osd
src/qt4       = qt4-gui
src/rms       = rms


# In order to have both a Qt and a KDE plugin, we make a mangled copy
# of the Qt plugin in the source tree.

post-patches:: preconfigure-kde4-gui

preconfigure-kde4-gui:
	cp -a plugins/qt4-gui plugins/kde4-gui
	touch $@

clean::
	rm -f preconfigure-kde4-gui
	rm -rf plugins/kde4-gui


# Build rules

# Tests disabled until google test 1.6.0 is supported
#configure/licq:: CMAKE_EXTRA_ARGS += -DBUILD_TESTS=ON
configure/licq:: $(CMAKE_BUILDDIR)/CMakeCache.txt
$(CMAKE_BUILDDIR)/CMakeCache.txt:
	mkdir -p $(@D)
	cd $(@D) && $(CMAKE) $(CURDIR) $(CMAKE_NORMAL_ARGS) $(CMAKE_EXTRA_ARGS)

build/licq:: debian/stamp-licq-build
debian/stamp-licq-build:
	$(DEB_MAKE_ENVVARS) $(MAKE) -C $(CMAKE_BUILDDIR)
	touch $@

clean::
	rm -f debian/stamp-licq-build
	rm -rf $(CMAKE_BUILDDIR)


# Plugins
define build-plugin
configure/licq-plugin-$(1):: CMAKE_EXTRA_ARGS += -DCMAKE_MODULE_PATH=$(CURDIR)/cmake
configure/licq-plugin-$(1):: plugins/$$(src/$(1))/$(CMAKE_BUILDDIR)/CMakeCache.txt
plugins/$$(src/$(1))/$(CMAKE_BUILDDIR)/CMakeCache.txt:
	mkdir -p $$(@D)
	cd $$(@D) && $$(CMAKE) $(CURDIR)/plugins/$$(src/$(1)) $$(CMAKE_NORMAL_ARGS) $$(CMAKE_EXTRA_ARGS)

build/licq-plugin-$(1):: debian/stamp-$(1)-build
debian/stamp-$(1)-build:
	$$(DEB_MAKE_ENVVARS) $$(MAKE) -C plugins/$$(src/$(1))/$(CMAKE_BUILDDIR)
	touch $$@

install/licq-plugin-$(1)::
	$$(DEB_MAKE_ENVVARS) $$(MAKE) -C plugins/$$(src/$(1))/$(CMAKE_BUILDDIR) install DESTDIR=$(CURDIR)/debian/licq-plugin-$(1)
ifeq ($(1),qt4)
	rm debian/licq-plugin-qt4/usr/share/licq/qt4-gui/emoticons/FeltTip4/LICENSE
	mkdir -p debian/licq-plugin-qt4-common/usr/share/licq
	mv debian/licq-plugin-qt4/usr/share/licq/qt4-gui debian/licq-plugin-qt4-common/usr/share/licq/
endif
ifneq ($(filter $(1), qt4 kde4),)
	rm -r debian/licq-plugin-$(1)/usr/share/licq
endif

clean::
	rm -f debian/stamp-$(1)-build
	rm -rf plugins/$$(src/$(1))/$(CMAKE_BUILDDIR)
endef

configure/licq-plugin-kde4:: CMAKE_EXTRA_ARGS += -DWITH_KDE=ON

$(foreach X,$(PLUGINS),$(eval $(call build-plugin,$(X))))


# Install rules

install/licq-plugin-qt4-common:: install/licq-plugin-qt4

install/licq install/licq-dev:: install-licq-common
install-licq-common::
	$(DEB_MAKE_ENVVARS) $(MAKE) -C $(CMAKE_BUILDDIR) install DESTDIR=$(CURDIR)/debian/licq
	mkdir -p debian/licq/usr/share/pixmaps
	cp plugins/qt4-gui/src/xpm/licq.xpm debian/licq/usr/share/pixmaps
	mkdir -p debian/licq-dev/usr
	mv debian/licq/usr/include debian/licq-dev/usr/include

## licq 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 option(USE_OPENSSL "Enable secure communication channels" ON)
 option(USE_SOCKS5 "Enable socks5 support" OFF)
 option(BUILD_PLUGINS "Build all plugins" OFF)
-option(BUILD_TESTS "Build all unit tests" OFF)
+option(BUILD_TESTS "Build all unit tests" ON)
 
 set(DLOPEN_POLICY RTLD_NOW CACHE STRING "2nd dlopen parameter")
 mark_as_advanced(DLOPEN_POLICY)
@@ -110,16 +110,14 @@
   set(SOCKS5_LIBRARIES ${SOCKS5_LIBRARY})
 endif (USE_SOCKS5)
 
-# Google Test is needed for unit tests
 if (BUILD_TESTS)
-  find_package(GTest)
-  if (NOT GTEST_FOUND)
-    message(FATAL_ERROR
-      "Google Test NOT found; disable unit tests by running cmake with -DBUILD_TESTS=OFF")
-  endif (NOT GTEST_FOUND)
-
   enable_testing()
   add_custom_target(tests ALL COMMAND ${CMAKE_CTEST_COMMAND} $(ARGS))
+
+  # Google Test
+  add_subdirectory(3rdparty/gtest)
+  set(GTEST_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/gtest/include")
+  set(GTEST_LIBRARIES gtest)
 
   # Google Mock
   add_subdirectory(3rdparty/gmock)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -110,11 +110,15 @@
 
 add_executable(licq ${licq_SRCS})
 
-# Add linker flags for thread support
-set_target_properties(licq PROPERTIES LINK_FLAGS "${CMAKE_THREAD_LIBS_INIT}")
+# Link with thread library
+target_link_libraries(licq ${CMAKE_THREAD_LIBS_INIT})
 
 # Must export symbols from daemon so that plugins can use them
-list(APPEND CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_EXPORTS_CXX_FLAG})
+set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_EXPORTS_CXX_FLAG}")
+
+# Print a message to stderr (and to the file <basedir>/licq.debug_rw_mutex) and
+# then abort if a (potential) deadlock is detected.
+set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DLICQDAEMON_DEBUG_RW_MUTEX=1")
 
 # To find public headers
 include_directories(BEFORE ${PROJECT_SOURCE_DIR}/include)
@@ -152,9 +156,8 @@
   target_link_libraries(unittests ${CMAKE_DL_LIBS})
   target_link_libraries(unittests ${SOCKET_LIBRARIES})
 
-  # Add linker flags for thread support
-  set_target_properties(unittests PROPERTIES
-    LINK_FLAGS "${CMAKE_THREAD_LIBS_INIT}")
+  # Link with thread library
+  target_link_libraries(unittests ${CMAKE_THREAD_LIBS_INIT})
 
   add_test(licq unittests)
   add_dependencies(tests unittests)

=== include/licq/CMakeLists.txt ===
set(licq_HEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/licqversion.h

  buffer.h
  byteorder.h
  color.h
  conversation.h
  daemon.h
  event.h
  gpghelper.h
  icq.h
  icqchat.h
  icqcodes.h
  icqdefines.h
  icqfiletransfer.h
  inifile.h
  macro.h
  md5.h
  oneventmanager.h
  packet.h
  pipe.h
  plugin.h
  pluginbase.h
  pluginmanager.h
  pluginsignal.h
  protocolbase.h
  protocolmanager.h
  protocolsignal.h
  proxy.h
  sarmanager.h
  socket.h
  socketmanager.h
  statistics.h
  translator.h
  userevents.h
  userid.h
  utility.h
  version.h
)

install(FILES ${licq_HEADERS} DESTINATION "${Licq_INCLUDE_DIR}/licq")

add_subdirectory(contactlist)
add_subdirectory(exceptions)
add_subdirectory(logging)
add_subdirectory(thread)

=== plugins/console/CMakeLists.txt ===
project(console)
cmake_minimum_required(VERSION 2.6.0)
cmake_policy(VERSION 2.6)

# Licq
find_package(Licq REQUIRED)
include_directories(${Licq_INCLUDE_DIRS})

# Generate pluginversion.h
include(version.cmake)
licq_create_plugin_version_file(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# NCruses
set(CURSES_NEED_NCURSES TRUE)
find_package(Curses REQUIRED)

# CDK
find_path(CDK_INCLUDE_DIR cdk.h PATH_SUFFIXES cdk)
if (CDK_INCLUDE_DIR)
  find_library(CDK_LIBRARY cdk)
endif (CDK_INCLUDE_DIR)

if (NOT CDK_LIBRARY)
  message(FATAL_ERROR "Could NOT find Curses Development Kit (CDK)")
endif (NOT CDK_LIBRARY)

add_subdirectory(src)

=== plugins/forwarder/CMakeLists.txt ===
project(forwarder)
cmake_minimum_required(VERSION 2.6.0)
cmake_policy(VERSION 2.6)

# Licq
find_package(Licq REQUIRED)
include_directories(${Licq_INCLUDE_DIRS})

# Generate pluginversion.h
include(version.cmake)
licq_create_plugin_version_file(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(src)

=== plugins/qt4-gui/CMakeLists.txt ===
project(Qt4-GUI)
cmake_minimum_required(VERSION 2.4.2)
include(CheckIncludeFile)
include(TestCXXAcceptsFlag)
include(CheckLibraryExists)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

# Use KDE support
option(WITH_KDE "Compile with KDE support" OFF)

# Licq
find_package(Licq REQUIRED)
include_directories(${Licq_INCLUDE_DIRS})

# Generate pluginversion.h
include(version.cmake)
licq_create_plugin_version_file(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(INSTALL_QTGUI_DIR qt4-gui CACHE STRING
  "Icons etc. will be installed to ${Licq_SHARE_DIR}/INSTALL_QTGUI_DIR.")
mark_as_advanced(INSTALL_QTGUI_DIR)

# Holds all libraries we should link to
set(LIBRARIES)

# Check for X11 and (optional) screensaver support
if (NOT APPLE)
  find_package(X11 REQUIRED)
  include_directories(${X11_INCLUDE_DIR})

  set(CMAKE_REQUIRED_LIBRARIES ${X11_LIBRARIES})
  check_library_exists(Xss XScreenSaverRegister "" HAVE_LIBXSS)
  check_include_file(X11/extensions/scrnsaver.h HAVE_SCRNSAVER_H)
  set(CMAKE_REQUIRED_LIBRARIES)

  if (HAVE_SCRNSAVER_H AND HAVE_LIBXSS)
    set(X11_LIBRARIES ${X11_LIBRARIES} Xss)
    set(USE_SCRNSAVER 1)
  endif (HAVE_SCRNSAVER_H AND HAVE_LIBXSS)
  set(LIBRARIES ${LIBRARIES} ${X11_LIBRARIES})
endif (NOT APPLE)


# Check for Qt4
set(QT_MIN_VERSION "4.3.0")

# Check for Qt unless WITH_KDE is requested
if (NOT WITH_KDE)
  find_package(Qt4 REQUIRED)

  # Check for HunSpell
  find_package(Hunspell)
  if (HUNSPELL_FOUND)
    set(HAVE_HUNSPELL 1)
    add_definitions(${HUNSPELL_DEFINITIONS})
    include_directories(${HUNSPELL_INCLUDE_DIRS})
    set(LIBRARIES ${LIBRARIES} ${HUNSPELL_LIBRARIES})
  endif (HUNSPELL_FOUND)

else (NOT WITH_KDE)
  # Stop KDE4 from adding an uninstall target
  set(_kde4_uninstall_rule_created TRUE)

  find_package(KDE4 REQUIRED)
  set(USE_KDE ${KDE4_FOUND})

  # Unset variables set by FindKDE4Internal
  set(LIBRARY_OUTPUT_PATH)

  # FindKDE4Internal adds "-Wl,--no-undefined" to the linker command
  # line. This doesn't work for use, since all symbols from the daemon
  # are undefined. So we remove it.
  string(REPLACE "-Wl,--no-undefined" ""
    CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}")

  # FindKDE4Internal adds "-fvisibility=hidden" to the compiler
  # command line. This hides symbols in the plugin that the daemon
  # looks for. So we remove it.
  string(REPLACE "-fvisibility=hidden" ""
    CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  # FindKDE4Internal disables exceptions, but the daemon is built with
  # exceptions so we must have them enabled here as well.
  string(REPLACE "-fno-exceptions" ""
    CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  string(REPLACE "-DQT_NO_EXCEPTIONS" ""
    CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  add_definitions(${KDE4_DEFINITIONS})
  link_directories(${KDE4_LIB_DIR})

  include_directories(${KDE4_INCLUDE_DIR})
  set(LIBRARIES ${LIBRARIES}
    ${KDE4_KDECORE_LIBS}
    ${KDE4_KDEUI_LIBS}
    ${KDE4_KIO_LIBS})
endif (NOT WITH_KDE)

set(QT_USE_QTXML 1)
include(${QT_USE_FILE})
set(LIBRARIES ${LIBRARIES} ${QT_LIBRARIES})

# Local includes
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

# Misc headers
check_include_file(locale.h HAVE_LOCALE_H)


# To find config.h
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

# Generate config.h
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config.h)

add_subdirectory(doc)
add_subdirectory(po)
add_subdirectory(share)
add_subdirectory(src)

=== plugins/aosd/src/CMakeLists.txt ===
set(aosd_SRCS
  conf.cpp
  iface.cpp
  plugin.cpp
)

licq_add_plugin(licq_aosd ${aosd_SRCS})
target_link_libraries(licq_aosd ${AOSD_LIBRARIES})

=== plugins/auto-reply/src/CMakeLists.txt ===
set(autoreply_SRCS
  autoreply.cpp
  main.cpp
)

licq_add_plugin(licq_autoreply ${autoreply_SRCS})

=== plugins/console/src/CMakeLists.txt ===
set(console_SRCS
  console.cpp
  console_menu.cpp
  console_print.cpp
  console_tab.cpp
  main.cpp
  window.cpp
)

licq_add_plugin(licq_console ${console_SRCS})

include_directories(${CURSES_INCLUDE_DIR})
include_directories(${CDK_INCLUDE_DIR})

target_link_libraries(licq_console ${CURSES_LIBRARIES})
target_link_libraries(licq_console ${CDK_LIBRARY})

=== plugins/forwarder/src/CMakeLists.txt ===
set(forwarder_SRCS
  forwarder.cpp
  main.cpp
)

licq_add_plugin(licq_forwarder ${forwarder_SRCS})

=== plugins/jabber/src/CMakeLists.txt ===
set(jabber_SRCS
  client.cpp
  config.cpp
  handler.cpp
  jabberplugin.cpp
  plugin.cpp
  sessionmanager.cpp
  vcard.cpp
)

licq_add_plugin(protocol_jabber ${jabber_SRCS})
target_link_libraries(protocol_jabber ${gloox_LIBRARIES})

=== plugins/msn/src/CMakeLists.txt ===
set(msn_SRCS
  msn-sb.cpp
  msn-srv.cpp
  msn-ssl.cpp
  msn.cpp
  msnbuffer.cpp
  msnevent.cpp
  msnpacket.cpp
  plugin.cpp
)

licq_add_plugin(protocol_msn ${msn_SRCS})

=== debian/changelog ===
licq (1.5.1-1) unstable; urgency=low

  * New upstream version 1.5.1 (Closes: #599071)
  * Refer to GPL version 2 explicit in copyright
  * Correct lintian overrides
  * Re-enable building of unit tests
  * Drop patches included in upstream release

 -- Erik Johansson <debian@ejohansson.se>  Fri, 01 Jul 2011 21:08:33 +0200

=== debian/rules ===
--- 
+++ 
@@ -52,8 +52,7 @@
 
 # Build rules
 
-# Tests disabled until google test 1.6.0 is supported
-#configure/licq:: CMAKE_EXTRA_ARGS += -DBUILD_TESTS=ON
+configure/licq:: CMAKE_EXTRA_ARGS += -DBUILD_TESTS=ON
 configure/licq:: $(CMAKE_BUILDDIR)/CMakeCache.txt
 $(CMAKE_BUILDDIR)/CMakeCache.txt:
 	mkdir -p $(@D)

## licq 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,7 @@
 # Functions
 check_function_exists(readdir_r HAVE_READDIR_R)
 check_function_exists(backtrace HAVE_BACKTRACE)
+check_function_exists(prctl HAVE_PRCTL)
 
 if(CMAKE_SYSTEM MATCHES "SunOS.*")
   # Make readdir_r on Solaris behave normally
@@ -112,7 +113,6 @@
 
 if (BUILD_TESTS)
   enable_testing()
-  add_custom_target(tests ALL COMMAND ${CMAKE_CTEST_COMMAND} $(ARGS))
 
   # Google Test
   add_subdirectory(3rdparty/gtest)
@@ -168,9 +168,12 @@
 
 add_subdirectory(cmake)
 add_subdirectory(include)
-add_subdirectory(po)
 add_subdirectory(share)
 add_subdirectory(src)
+
+if (ENABLE_NLS)
+  add_subdirectory(po)
+endif (ENABLE_NLS)
 
 if (BUILD_PLUGINS)
   add_subdirectory(plugins)

=== include/licq/CMakeLists.txt ===
--- 
+++ 
@@ -8,22 +8,13 @@
   daemon.h
   event.h
   gpghelper.h
-  icq.h
-  icqchat.h
-  icqcodes.h
-  icqdefines.h
-  icqfiletransfer.h
   inifile.h
   macro.h
   md5.h
   oneventmanager.h
   packet.h
   pipe.h
-  plugin.h
-  pluginbase.h
-  pluginmanager.h
   pluginsignal.h
-  protocolbase.h
   protocolmanager.h
   protocolsignal.h
   proxy.h
@@ -42,5 +33,7 @@
 
 add_subdirectory(contactlist)
 add_subdirectory(exceptions)
+add_subdirectory(icq)
 add_subdirectory(logging)
+add_subdirectory(plugin)
 add_subdirectory(thread)

=== plugins/osd/src/CMakeLists.txt ===
set(osd_SRCS
  licq-osd.cpp
  my_xosd.cpp
  plugin.cpp
)

licq_add_plugin(licq_osd ${osd_SRCS})

add_definitions(-DPACKAGE="licq_osd_plugin")
add_definitions(-DLOCALEDIR="${Licq_LOCALE_DIR}")

if (ICONV_SECOND_ARGUMENT_IS_CONST)
  add_definitions(-DICONV_CONST=const)
else (ICONV_SECOND_ARGUMENT_IS_CONST)
  add_definitions(-DICONV_CONST=)
endif (ICONV_SECOND_ARGUMENT_IS_CONST)

include_directories(${XOSD_INCLUDE_DIR})
include_directories(${ICONV_INCLUDE_DIR})

target_link_libraries(licq_osd ${XOSD_LIBRARY})
target_link_libraries(licq_osd ${ICONV_LIBRARIES})

=== debian/changelog ===
licq (1.6.0-2build1) quantal; urgency=low

  * No change rebuild against boost1.49

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Tue, 19 Jun 2012 10:07:47 +0100

licq (1.6.0-2) unstable; urgency=low

  * Bump debhelper compat to 8
  * Build kde4 plugin without copying qt4 dir first

 -- Erik Johansson <debian@ejohansson.se>  Mon, 05 Dec 2011 21:00:09 +0100

licq (1.6.0-1) unstable; urgency=low

  * New upstream version 1.6.0 (Closes: #271035)

 -- Erik Johansson <debian@ejohansson.se>  Mon, 31 Oct 2011 19:50:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: licq
-Build-Depends: cdbs (>= 0.4.52), cmake (>= 2.6.0), debhelper (>= 6.0.7), imagemagick, kdelibs5-dev, libboost-dev (>= 1.33.1), libcdk5-dev, libgloox-dev (>= 1.0), libgpgme11-dev (>= 0.4.2), libgtest-dev (>= 1.5.0), libhunspell-dev, libncurses5-dev, libqt4-dev (>= 4.3.0), libssl-dev, libxosd-dev (>= 2.1.0), libxss-dev, qt4-dev-tools
+Build-Depends: cdbs (>= 0.4.52), cmake (>= 2.6.0), debhelper (>= 8), imagemagick, kdelibs5-dev, libboost-dev (>= 1.36.0), libboost-regex-dev (>= 1.36.0), libcdk5-dev, libgloox-dev (>= 1.0), libgpgme11-dev (>= 0.4.2), libhunspell-dev, libncurses5-dev, libqt4-dev (>= 4.3.0), libssl-dev, libxosd-dev (>= 2.1.0), libxss-dev, qt4-dev-tools
 Section: net
 Priority: optional
 Maintainer: Erik Johansson <debian@ejohansson.se>

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 # cmake settings
 CMAKE = cmake
-CMAKE_BUILDDIR = obj-$(DEB_BUILD_GNU_TYPE)
+CMAKE_BUILDDIR = obj-$(if $(1),$(1)-)$(DEB_BUILD_GNU_TYPE)
 CMAKE_INSTALL_PREFIX = /usr
 CMAKE_NORMAL_ARGS  = -DCMAKE_INSTALL_PREFIX="$(CMAKE_INSTALL_PREFIX)"
 CMAKE_NORMAL_ARGS += -DCMAKE_C_COMPILER:FILEPATH="$(CC)"
@@ -29,25 +29,11 @@
 src/console   = console
 src/forwarder = forwarder
 src/jabber    = jabber
-src/kde4      = kde4-gui
+src/kde4      = qt4-gui
 src/msn       = msn
 src/osd       = osd
 src/qt4       = qt4-gui
 src/rms       = rms
-
-
-# In order to have both a Qt and a KDE plugin, we make a mangled copy
-# of the Qt plugin in the source tree.
-
-post-patches:: preconfigure-kde4-gui
-
-preconfigure-kde4-gui:
-	cp -a plugins/qt4-gui plugins/kde4-gui
-	touch $@
-
-clean::
-	rm -f preconfigure-kde4-gui
-	rm -rf plugins/kde4-gui
 
 
 # Build rules

## licq 1.6.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,10 +8,10 @@
   logging/logutils.cpp
   logging/pluginlogsink.cpp
 
-  plugins/generalplugin.cpp
-  plugins/plugin.cpp
-  plugins/pluginthread.cpp
-  plugins/protocolplugin.cpp
+  plugin/generalplugin.cpp
+  plugin/plugin.cpp
+  plugin/pluginthread.cpp
+  plugin/protocolplugin.cpp
 
   thread/condition.cpp
   thread/mutexlocker.cpp
@@ -27,6 +27,7 @@
   daemon.cpp
   event.cpp
   fifo.cpp
+  filter.cpp
   gpghelper.cpp
   hebrev.c
   licq.cpp
@@ -36,13 +37,11 @@
   packet.cpp
   protocolmanager.cpp
   proxy.cpp
-  rtf.cc
   sarmanager.cpp
   sighandler.cpp
   socket.cpp
   socketmanager.cpp
   statistics.cpp
-  support.c
   translator.cpp
   userevents.cpp
   utility.cpp
@@ -62,14 +61,15 @@
   icq/icqprotocolplugin.cpp
   icq/oscarservice.cpp
   icq/packet.cpp
+  icq/rtf.cc
   icq/threads.cpp
+  icq/userclients.cpp
 
   logging/logservice.cpp
   logging/streamlogsink.cpp
   logging/threadlog.cpp
 
-  plugins/plugineventhandler.cpp
-  plugins/pluginmanager.cpp
+  plugin/pluginmanager.cpp
 
   ${tested_SRCS}
 )
@@ -84,10 +84,10 @@
   logging/tests/logutilstest.cpp
   logging/tests/pluginlogsinktest.cpp
 
-  plugins/tests/generalplugintest.cpp
-  plugins/tests/plugintest.cpp
-  plugins/tests/pluginthreadtest.cpp
-  plugins/tests/protocolplugintest.cpp
+  plugin/tests/generalplugintest.cpp
+  plugin/tests/plugintest.cpp
+  plugin/tests/pluginthreadtest.cpp
+  plugin/tests/protocolplugintest.cpp
 
   thread/tests/conditiontest.cpp
   thread/tests/mutextest.cpp
@@ -98,12 +98,9 @@
   utils/tests/dynamiclibrarytest.cpp
   utils/tests/pipetest.cpp
 
-  # Needed or IniFile won't find gLog
-  logging/logservice.cpp
-  logging/threadlog.cpp
-
-  # A dummy gDaemon to make tests compile without having to pull in the read daemon.cpp
+  # Dummy global instances to make tests compile
   tests/daemon_dummy.cpp
+  tests/log_dummy.cpp
 
   ${tested_SRCS}
 )
@@ -142,6 +139,7 @@
 target_link_libraries(licq ${OPENSSL_LIBRARIES})
 target_link_libraries(licq ${SOCKET_LIBRARIES})
 target_link_libraries(licq ${SOCKS5_LIBRARIES})
+target_link_libraries(licq ${Boost_LIBRARIES})
 
 install(TARGETS licq RUNTIME DESTINATION bin)
 
@@ -149,16 +147,24 @@
   include_directories(${GTEST_INCLUDE_DIRS})
   include_directories(${GMOCK_INCLUDE_DIRS})
 
-  add_executable(unittests ${test_SRCS})
+  add_executable(unittest ${test_SRCS})
 
-  target_link_libraries(unittests ${GTEST_LIBRARIES})
-  target_link_libraries(unittests ${GMOCK_LIBRARIES})
-  target_link_libraries(unittests ${CMAKE_DL_LIBS})
-  target_link_libraries(unittests ${SOCKET_LIBRARIES})
+  target_link_libraries(unittest ${GTEST_LIBRARIES})
+  target_link_libraries(unittest ${GMOCK_LIBRARIES})
+  target_link_libraries(unittest ${CMAKE_DL_LIBS})
+  target_link_libraries(unittest ${SOCKET_LIBRARIES})
 
   # Link with thread library
-  target_link_libraries(unittests ${CMAKE_THREAD_LIBS_INIT})
+  target_link_libraries(unittest ${CMAKE_THREAD_LIBS_INIT})
 
-  add_test(licq unittests)
-  add_dependencies(tests unittests)
+  add_test(licq unittest)
+
+  set(unittest_stamp
+    "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/unittest.stamp")
+  add_custom_command(OUTPUT "${unittest_stamp}"
+    COMMAND ${CMAKE_CTEST_COMMAND} $(ARGS)
+    COMMAND ${CMAKE_COMMAND} -E touch "${unittest_stamp}"
+    COMMENT "Running unit test"
+    DEPENDS unittest)
+  add_custom_target(unittest_run ALL DEPENDS "${unittest_stamp}")
 endif (BUILD_TESTS)

=== include/licq/icq/CMakeLists.txt ===
set(licq_HEADERS
  chat.h
  codes.h
  filetransfer.h
  icq.h
)

install(FILES ${licq_HEADERS} DESTINATION "${Licq_INCLUDE_DIR}/licq/icq")

=== include/licq/plugin/CMakeLists.txt ===
set(licq_HEADERS
  generalbase.h
  generalplugin.h
  plugin.h
  pluginmanager.h
  protocolbase.h
  protocolplugin.h
)

install(FILES ${licq_HEADERS} DESTINATION "${Licq_INCLUDE_DIR}/licq/plugin")

=== debian/changelog ===
licq (1.6.1-1) unstable; urgency=low

  * New upstream version 1.6.1
  * Don't run tests if nocheck is given in DEB_BUILD_OPTIONS
  * Bump standards version to 3.9.3 with no changes

 -- Erik Johansson <debian@ejohansson.se>  Sat, 16 Jun 2012 23:02:32 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: net
 Priority: optional
 Maintainer: Erik Johansson <debian@ejohansson.se>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Git: git://github.com/licq-im/debian.git
 Vcs-Browser: https://github.com/licq-im/debian
 Homepage: http://www.licq.org/

=== debian/rules ===
--- 
+++ 
@@ -38,7 +38,12 @@
 
 # Build rules
 
+ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
 configure/licq:: CMAKE_EXTRA_ARGS += -DBUILD_TESTS=ON
+else
+configure/licq:: CMAKE_EXTRA_ARGS += -DBUILD_TESTS=OFF
+endif
+
 configure/licq:: $(CMAKE_BUILDDIR)/CMakeCache.txt
 $(CMAKE_BUILDDIR)/CMakeCache.txt:
 	mkdir -p $(@D)

## licq 1.7.0

=== debian/changelog ===
licq (1.7.0-1) unstable; urgency=low

  * New upstream version 1.7.0

 -- Erik Johansson <debian@ejohansson.se>  Wed, 31 Oct 2012 21:30:00 +0100

licq (1.6.1-3) unstable; urgency=low

  * Add lintian override for hardening-no-fortify-functions
  * Make licq depend on a UI plugin (Closes: #681678)

 -- Erik Johansson <debian@ejohansson.se>  Sun, 29 Jul 2012 22:23:12 +0200

licq (1.6.1-2) unstable; urgency=low

  * Bump debhelper compat to 9
  * Add CPPFLAGS to CFLAGS and CXXFLAGS
  * Fix typo in licq-plugin-qt4's description (Closes: #679029)
  * Set CMAKE_*_LINKER_FLAGS from LDFLAGS

 -- Erik Johansson <debian@ejohansson.se>  Thu, 28 Jun 2012 23:31:01 +0200
